<!DOCTYPE html>
<html lang="en-US">

<head>
  <title>NYT Top Stories</title>

  <meta charset="utf-8">

  <!-- Force latest available IE rendering engine and Chrome Frame (if installed) -->
  <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">

  <!-- Mobile Screen Resizing -->
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <link href="https://fonts.googleapis.com/css?family=Work+Sans" rel="stylesheet">

  <style type="text/css">
    /**
		 * Add box sizing to everything
		 * @link http://www.paulirish.com/2012/box-sizing-border-box-ftw/
		 */
    /* line 38, src/sass/components/_normalize.scss */
    *,
    *:before,
    *:after {
      box-sizing: border-box;
    }

    /**
		 * Layout
		 */
    body {
      font-family: 'Work Sans', sans-serif;
      font-size: 112.5%;
      margin-left: auto;
      margin-right: auto;
      max-width: 40em;
      width: 88%;
    }

    img {
      height: auto;
      max-width: 100%;
    }

    /**
		 * Article Styles
		 */
		a {
      text-decoration: none;
    }
    a::after{
      content: "\2192";
      padding-left: .3rem;
    }
    h2 {
      padding-bottom: .2rem;
      margin: 0;
    }
    article {
      border-bottom: 1px solid #999;
      margin-bottom: 2rem;
      padding-bottom: 1rem;
    }
    .byline { display: flex;}
    .byline em { padding-right: 1rem}
  </style>
</head>

<body>

  <h1>What to read today</h1>

  <!-- Load number of articles -->
  <div class="buttons">
    <button value="10" data-count>Show 10 articles</button>
    <button value="15" data-count>Show 15 articles</button>
    <button value="20" data-count>Show 20 articles</button>
  </div>

  <input type="text" name="" value="5" data-articles />
  <div class="">
    <select  id="nyt-sections" name="section">
      <option value="arts">arts</option>
      <option value="automobiles">automobiles</option>
      <option value="books">books</option>
      <option value="business">business</option>
      <option value="fashion">fashion</option>
      <option value="food">food</option>
      <option value="health">health</option>
      <option value="home">home</option>
      <option value="insider">insider</option>
      <option value="magazine">magazine</option>
      <option value="movies">movies</option>
      <option value="national">national</option>
      <option value="nyregion">nyregion</option>
      <option value="obituaries">obituaries</option>
      <option value="opinion">opinion</option>
      <option value="politics">politics</option>
      <option value="realestate">realestate</option>
      <option value="science">science</option>
      <option value="sports">sports</option>
      <option value="sundayreview">sundayreview</option>
      <option value="technology">technology</option>
      <option value="theater">theater</option>
      <option value="tmagazine">tmagazine</option>
      <option value="travel">travel</option>
      <option value="upshot">upshot</option>
      <option value="world">world</option>
    </select>
  </div>

  <div id="app"></div>


  <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/dompurify/1.0.9/purify.min.js">
  </script>
  <script>
    (function() {

      // DOM elements
      const xhr = new XMLHttpRequest(),
      stories_app = document.querySelector('#app'),
      section_val = document.querySelector('#nyt-sections');

      /**
       *  Hook into NYT API and display the data
       *  @param {Node} selector Element wrapping the data
       *  @param {String} section NYT section
       *  @param {Number} count The number of articles loaded into the DOM
       */

      const topStories = (selector, section, count) => {
        // Setup our listener to process request state changes
        if (count === undefined) {
          count = 5
        }
        xhr.onreadystatechange = function() {

          // if readyState is unsuccessful or selecor doesn't exist bail
          if (xhr.readyState !== 4 || !selector) return;

          // Process our return data
          // let data = JSON.parse(JSON.stringify(xhr.responseText)).join('');

          let data = JSON.parse(xhr.responseText),
          results = data.results.slice(0,count)


          if (xhr.status >= 200 && xhr.status < 300 ) {
            const html = []

            results.forEach(r => {

              // Convert unix timestamp
              let date = new Date(r.updated_date),
              updated = date.toDateString();

              // HTML template literal
              html.push( `
                <article>
                  <h3>${r.section}</h3>
                  <h2>${r.title}</h2>
                  <div class="byline">
                    <p><em>${r.byline}</em></p>
                    <p><small>${updated}</small></p>
                  </div>
                  <a href="${r.url}">Read More</a>
                </article>
              `)
            });

            selector.innerHTML = DOMPurify.sanitize(html.join(''))

          } else {
            alert('Something went wrong.  Try again later');
          }
        }

        let api = {
          url: 'https://api.nytimes.com/svc/topstories/v2/',
          section: section,
          key: '.json?api-key=sajHbASr4J8WrME0e80T9DOWSwkDbags'
        };

        xhr.open('GET', api.url + api.section + api.key);
        xhr.send();
      };

      // Display sections on page load
      // starting with the default number of articles

      let article_count = document.querySelector('[data-articles]'),
      articles = article_count.value;

      topStories(stories_app, section_val.value, articles)

      // Setup content reload
      document.addEventListener('input', function(e) {
        if (e.target.matches('#nyt-sections')) {
          topStories(stories_app, e.target.value, articles)
        }
      }, false);

      document.addEventListener('click', function(e) {
        if (e.target.matches('[data-count]')) {
          articles = e.target.value
          // console.log(articles, e.target.value);
          topStories(stories_app, e.target.value, articles)
        }
      }, false);

    })();
  </script>

</body>

</html>
